#include "Image.hpp"
#include "SDL_image.h"
#include <stdexcept>

using namespace sc::gui;

Image::Image(int w, int h) {
    SDL_Surface* s {SDL_CreateRGBSurface(0, w, h, 32, 0, 0, 0, 0)};
    _s.reset(s);
}

Image::Image(const std::string& path) {
    // load image from file into surface
    SDL_Surface* loaded = IMG_Load(path.c_str());
    if (!loaded) throw std::runtime_error(IMG_GetError());
    _s.reset(loaded);
}

Image::Image(SDL_Surface* surface) {
    _s.reset(surface);
}
